//+------------------------------------------------------------------+
//|                                                        FRAMA.mq4 |
//|                                                             Rosh |
//|                    http://www.alpari-idc.ru/ru/experts/articles/ |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DimGray  
#property indicator_color2  DeepSkyBlue 
#property indicator_color3  DeepSkyBlue 
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed 
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    PeriodFrama     = 34;
extern int    PriceType       = 0;
extern double SmoothLength    = 10;
extern double SmoothPhase     = 0;
extern bool   SmoothDouble    = false;
extern bool   TrendMode       = false;
extern bool   Interpolate     = true;
extern bool   MultiColor      = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;


//
//
//
//
//

double buffer[];
double bufferUa[];
double bufferUb[];
double bufferDa[];
double bufferDb[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0,buffer);
   SetIndexBuffer(1,bufferUa);
   SetIndexBuffer(2,bufferUb);
   SetIndexBuffer(3,bufferDa);
   SetIndexBuffer(4,bufferDb);
   SetIndexBuffer(5,slope);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" frama on jurik ");
   return(0);
}
   
//
//
//
//
//

int deinit(){ return(0);}

//
//
//
//
//
 
   

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,n,k,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars)  { buffer[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
 
   
   if (!calculateValue && MultiColor && slope[limit]==  1) CleanPoint(limit,bufferUa,bufferUb);
   if (!calculateValue && MultiColor && slope[limit]== -1) CleanPoint(limit,bufferDa,bufferDb);
   
   //
   //
   //
   //
   //        
      
   for (i=limit; i>=0; i--)
   {
          double hi1  = High[iHighest(Symbol(),0,MODE_HIGH,  PeriodFrama,i)];
          double lo1  = Low[ iLowest(Symbol(), 0,MODE_LOW,   PeriodFrama,i)];
          double hi2  = High[iHighest(Symbol(),0,MODE_HIGH,  PeriodFrama,i+PeriodFrama)];
          double lo2  = Low[ iLowest(Symbol(), 0,MODE_LOW,   PeriodFrama,i+PeriodFrama)];
          double hi3  = High[iHighest(Symbol(),0,MODE_HIGH,2*PeriodFrama,i)];
          double lo3  = Low[ iLowest(Symbol(), 0,MODE_LOW, 2*PeriodFrama,i)];
          double n1   = (hi1-lo1)/PeriodFrama;
          double n2   = (hi2-lo2)/PeriodFrama;
          double n3   = (hi3-lo3)/(2.0*PeriodFrama);
          double d    = (MathLog(n1+n2)-MathLog(n3))/MathLog(2.0);
          double alfa = MathExp(-4.6*(d-1.0));
   
          buffer[i]   = iDSmooth(alfa * Price(i) + (1-alfa) * buffer[i+1],SmoothLength,SmoothPhase,SmoothDouble,i,0);
          bufferUa[i] = EMPTY_VALUE;
          bufferUb[i] = EMPTY_VALUE;
          bufferDa[i] = EMPTY_VALUE;
          bufferDb[i] = EMPTY_VALUE;

            if (TrendMode)
                  slope[i] = slope[i+1];
            else  slope[i] = 0;
            
            if (buffer[i] > buffer[i+1]) slope[i] =  1;
            if (buffer[i] < buffer[i+1]) slope[i] = -1;
            
      if (!calculateValue && MultiColor && slope[i]==  1) PlotPoint(i,bufferUa,bufferUb,buffer);
      if (!calculateValue && MultiColor && slope[i]== -1) PlotPoint(i,bufferDa,bufferDb,buffer);
      
      //
      //
      //
      //
      //
      
      }
      
      manageAlerts();
      return(0);
      }
     
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (MultiColor && slope[limit]==  1) CleanPoint(limit,bufferUa,bufferUb);
      if (MultiColor && slope[limit]== -1) CleanPoint(limit,bufferDa,bufferDb);
      for(i=limit; i>=0; i--)
      {  
   
      int y = iBarShift(NULL,timeFrame,Time[i]);
          buffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodFrama,PriceType,SmoothLength,SmoothPhase,SmoothDouble,TrendMode,0,y);
          slope[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodFrama,PriceType,SmoothLength,SmoothPhase,SmoothDouble,TrendMode,5,y);
          bufferUa[i] = EMPTY_VALUE;
          bufferUb[i] = EMPTY_VALUE;
          bufferDa[i] = EMPTY_VALUE;
          bufferDb[i] = EMPTY_VALUE;
      
          //
          //
          //
          //
          //
        
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      
          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
          for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
          for(k = 1; k < n; k++)
          {
  	           buffer[i+k] = buffer[i] + (buffer[i+n]- buffer[i]) * k/n;
      
          }
          }
      
          //
          //
          //
          //
          //
          
          for (i=limit;i>=0;i--)
          {
          if (MultiColor && slope[i]==  1) PlotPoint(i,bufferUa,bufferUb,buffer);
          if (MultiColor && slope[i]== -1) PlotPoint(i,bufferDa,bufferDb,buffer);
          }
          
          //
          //
          //
          //
          //
          
          manageAlerts();
          return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(whichBar,"up");
         if (slope[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Frama on jurik changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Frama on jurik  "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
    
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

double Price(int shift)
  {

   double res;

   switch (PriceType)
      {
      case PRICE_OPEN:     res = Open[shift]; break;
      case PRICE_HIGH:     res = High[shift]; break;
      case PRICE_LOW:      res = Low[shift];  break;
      case PRICE_MEDIAN:   res = (High[shift]+Low[shift])/2.0; break;
      case PRICE_TYPICAL:  res = (High[shift]+Low[shift]+  Close[shift])/3.0; break;
      case PRICE_WEIGHTED: res = (High[shift]+Low[shift]+2*Close[shift])/4.0; break;
      default:             res = Close[shift];break;
      }
   return(res);
  }
  
  //+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}